/* Plugin generated by AMXX-Studio */

#include <amxmodx>
#include <amxmisc>
#include <cstrike>
#include <fakemeta>
#include <fun>
#include <hamsandwich>

#define PLUGIN "Custom Weapon"
#define VERSION "1.0"
#define AUTHOR "DavidJr"

new const Wpn_Base = 28; // AK-47
new const Wpn_Clip = 30;
new const Wpn_Ammo = 120;
new const Wpn_Cost = 3000;
new const Float:Wpn_Damage = 2.0;

new const Wpn_Cmd[] = "buy_wpn";

new const Wpn_Model[] =
{
	"models/p_weapon.mdl",
	"models/v_weapon.mdl",
	"models/w_weapon.mdl"
};

enum
{
	_P = 0,
	_V,
	_W
};

new const Wpn_Sound[] =
{
	"weapons/wpn_shoot1.wav",
	"weapons/wpn_shoot2.wav"
};

new const Wpn_Msg[] =
{
	"You already own that weapon",
	"You have insufficient money"
};

enum
{
	WPN_HAVE = 0,
	WPN_INSUFFICIENT
}

new gWpn[32], gCSWpn[32], gClip[32], gAmmo[32];

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR);
	
	register_event("CurWeapon", "Event_CurWeapon", "b");
	
	register_forward(FM_SetModel, "fw_SetModel");
	
	RegisterHam(Ham_TakeDamage, "player", "OnCBase_TakeDamage");
	
	RegisterHam(Ham_Touch, "weaponbox", "OnCBase_Touch");
	
	register_clcmd(Wpn_Cmd, "Cmd_Buy");
}

public plugin_precache()
{
	for (new i = 0; i < sizeof Wpn_Model; ++i)
	{
		precache_model(Wpn_Model[i]);
	}
	
	for (new i = 0; i < sizeof Wpn_Sound; ++i)
	{
		precache_sound(Wpn_Sound[i]);
	}
}

public client_connect(iIndex)
{
	Wpn_Init(iIndex);
}

public client_disconnect(iIndex)
{
	Wpn_Free(iIndex);
}

public Event_CurWeapon(iIndex)
{
	if (!gWpn[iIndex]) return;
	
	new iClip, iAmmo;
	new iWpn = get_user_weapon(iIndex, iClip, iAmmo);
	
	if (iWpn != Wpn_Base) return;
	
	if (iWpn != gCSWpn[iIndex])
	{
		Wpn_SetModel(iIndex);
		gCSWpn[iIndex] = iWpn;
	}
	
	gClip[iIndex] = iClip;
	gAmmo[iIndex] = iAmmo;
}

public fw_SetModel(iEnt, szMdl[])
{
	if (!pev_valid(iEnt)) return;
	
	new iIndex = pev(iEnt, pev_owner);
	
	if (gWpn[iIndex])
	{
		set_pev(iEnt, pev_model, Wpn_Model[_W]);
		set_pev(iEnt, pev_iuser1, gWpn[iIndex]);
		set_pev(iEnt, pev_iuser2, gCSWpn[iIndex]);
		set_pev(iEnt, pev_iuser3, gClip[iIndex]);
		set_pev(iEnt, pev_iuser4, gAmmo[iIndex]);
		gWpn[iIndex] = 0;
	}
}

public OnCBase_TakeDamage(Victim, Inflictor, Attacker, Float:flDamage, DamageBits)
{
	new iWpn = get_user_weapon(Attacker);
	
	if (!gWpn[Attacker]) return HAM_IGNORED;
	if (iWpn != Wpn_Base) return HAM_IGNORED;
	
	SetHamParamFloat(4, flDamage * Wpn_Damage);
	return HAM_SUPERCEDE;
}

public OnCBase_Touch(iEnt, iIndex)
{
	new iWpn	= pev(iEnt, pev_iuser1);
	new iCSWpn	= pev(iEnt, pev_iuser2);
	new iClip	= pev(iEnt, pev_iuser3);
	new iAmmo	= pev(iEnt, pev_iuser4);
	
	gWpn[iIndex] = iWpn;
	gClip[iIndex] = iClip;
	gAmmo[iIndex] = iAmmo;
	
	new szClass[32];
	pev(iEnt, pev_classname, szClass, sizeof (szClass) - 1);
	
	Wpn_SetAmmo(iIndex, iCSWpn, iClip, iAmmo);
}

public Cmd_Buy(iIndex)
{
	if (gWpn[iIndex])
	{
		client_print(iIndex, print_center, "%s", Wpn_Msg[WPN_HAVE]);
		return PLUGIN_HANDLED;
	}
	
	new iMoney = cs_get_user_money(iIndex)
	
	if (iMoney < Wpn_Cost)
	{
		client_print(iIndex, print_center, "%s", Wpn_Msg[WPN_INSUFFICIENT]);
		return PLUGIN_HANDLED;
	}
	
	cs_set_user_money(iIndex, iMoney - Wpn_Cost, 1);
	Wpn_Give(iIndex);
	Wpn_SetModel(iIndex);
	
	return PLUGIN_HANDLED;
}

public Wpn_Init(iIndex)
{
	gWpn[iIndex]	= 0;
	gClip[iIndex]	= 0;
	gAmmo[iIndex]	= 0;
}

public Wpn_Free(iIndex)
{
	gWpn[iIndex]	= 0;
	gClip[iIndex]	= 0;
	gAmmo[iIndex]	= 0;
}

public Wpn_Give(iIndex)
{
	new szModel[32];
	get_weaponname(iIndex, szModel, sizeof (szModel) - 1);
	
	give_item(iIndex, szModel);
	Wpn_SetAmmo(iIndex, Wpn_Base, Wpn_Clip, Wpn_Ammo);
	
	gWpn[iIndex] = 1;
}

public Wpn_SetAmmo(iIndex, iBase, iClip, iAmmo)
{
	new szModel[32];
	get_weaponname(iBase, szModel, sizeof (szModel) - 1);
	
	new iEnt = get_weaponid(szModel);
	
	cs_set_weapon_ammo(iEnt, iClip);
	cs_set_user_bpammo(iIndex, iClip, iAmmo);
}

public Wpn_SetModel(iIndex)
{
	if (!gWpn[iIndex]) return;
	
	new iWpn = get_user_weapon(iIndex);
	
	if (iWpn != Wpn_Base) return;
	
	set_pev(iIndex, pev_weaponmodel2, Wpn_Model[_P]);
	set_pev(iIndex, pev_viewmodel2, Wpn_Model[_V]);
}